_TEXT    SEGMENT PARA PUBLIC 'CODE'
    ASSUME CS:_TEXT,DS:_TEXT,SS:_TEXT,ES:_TEXT ;ALREADY SET BY DOS LOADER
;
extrn semaphore:byte
extrn do_window:near,undo_window:near
extrn interrupts:word
save_1 dw  14*33 dup(0)
save_2 dw  23*56  dup(0)
public save_2
istack   db 128 dup(0)
; data areas
reset    dd   0f000fff0h  ; finally found the absolute vector
save_sp dw 0
save_ss dw 0
public save_ss,save_sp
dsreg   dw 0
esreg   dw 0
mode   db 0
public mode
enter_sp  dw  0
public enter_sp
window  db 10,02,007h
    dw  save_1
    db  '    Resident Boot Control',10
    db  '     by Keith P. Graham',10
    db  ' 1. Reboot (Ctrl-Alt-Del)',10
    db  ' 2. Reboot With Memory Check',10
    db  ' 3. Terminate Current Program ',10
    db  ' 4. Restore Interrupts',10
    db  ' 5. Display Interrupts',10
    db  ' 6. Port Control',10
    db  ' 7. Rebuild DOS MALLOC Map',10
    db  ' 8. Exit with Debug Break',10
    db  ' 9. Restore Video Mode',10
    db  '    Press Esc to exit',10,0
info3  db 10,02,007h
    dw  save_2
    db  ' Entry point is first instruction after INT 3 and IRET',10
    db 0
fixm1  db 10,02,007h
    dw  save_2
    db  ' Memory Map may be fixed',10
    db 0
fixm2  db 10,02,007h
    dw  save_2
    db  ' Map fix unsuccessful',10
    db 0
window2 db 1,1,007h
    dw  save_2
    db  'CS:IP='
csip db '0000:0000'
    db  ' DS='
ds_d db '0000'
    db  ' ES='
ds_e db '0000'
    db  ' SS='
ds_s db '0000'
    db  ' SP='
ds_2 db '0000',10
     db  'Interrupt Vectors',10
     db  ' #   CS:IP    #   CS:IP    #   CS:IP    #   CS:IP',10
  ; this is 2,b,4:4,b * 4 = 13*4= 52
int0 db  '00 0000:0000 00 0000:0000 00 0000:0000 00 0000:0000',10
     db  '00 0000:0000 00 0000:0000 00 0000:0000 00 0000:0000',10
     db  '00 0000:0000 00 0000:0000 00 0000:0000 00 0000:0000',10
     db  '00 0000:0000 00 0000:0000 00 0000:0000 00 0000:0000',10
     db  '00 0000:0000 00 0000:0000 00 0000:0000 00 0000:0000',10
     db  '00 0000:0000 00 0000:0000 00 0000:0000 00 0000:0000',10
     db  '00 0000:0000 00 0000:0000 00 0000:0000 00 0000:0000',10
     db  '00 0000:0000 00 0000:0000 00 0000:0000 00 0000:0000',10
     db  '00 0000:0000 00 0000:0000 00 0000:0000 00 0000:0000',10
     db  '00 0000:0000 00 0000:0000 00 0000:0000 00 0000:0000',10
     db  '00 0000:0000 00 0000:0000 00 0000:0000 00 0000:0000',10
     db  '00 0000:0000 00 0000:0000 00 0000:0000 00 0000:0000',10
     db  '00 0000:0000 00 0000:0000 00 0000:0000 00 0000:0000',10
     db  '00 0000:0000 00 0000:0000 00 0000:0000 00 0000:0000',10
     db  '00 0000:0000 00 0000:0000 00 0000:0000 00 0000:0000',10
     db  '00 0000:0000 00 0000:0000 00 0000:0000 00 0000:0000',10
     db  '  Press Esc to exit ',10,0
printer  dw 0
storehexb:
     mov  cl,16
     mov  ah,0
     jmp  hexb_enter
storehex:
public  storehex
; ax has something to convert to hex, es:di has where
    mov   dx,0
    xchg  dl,ah
    xchg  ax,dx
    mov   ah,0
    mov   cl,16
    div   cl
    or    ax,3030h
    cmp   al,'9'
    jle   f5a
    add   al,7
f5a:
    cmp   ah,'9'
    jle   f5b
    add   ah,7
f5b:
    stosw
    mov   ax,dx
hexb_enter:
    mov   ah,0
    div   cl
    or    ax,3030h
    cmp   al,'9'
    jle   f5c
    add   al,7
f5c:
    cmp   ah,'9'
    jle   f5d
    add   ah,7
f5d:
    stosw
    ret
saveax  dw 0
save_all:
public save_all
; this routine does a super save. AX must be saved previously
    pop   ax
    mov   cs:saveax,ax
    mov   cs:save_ss,ss
    mov   cs:save_sp,sp
    mov   ax,cs
    mov   ss,ax
    mov   sp,offset istack+126
    push  bx
    push  cx
    push  dx
    push  bp
    push  si
    push  di
    push  ds
    push  es
    mov   ax,cs:saveax
    push  ax      ; push return back into stack
    mov   cs:dsreg,ds
    mov   cs:esreg,es
    cld
    mov   ax,cs
    mov   ds,ax
    mov   es,ax
    ret
restore_all:
public restore_all
    pop   ax  ; get the return address
    pop   es
    pop   ds
    pop   di
    pop   si
    pop   bp
    pop   dx
    pop   cx
    pop   bx
    mov   ss,cs:save_ss
    mov   sp,cs:save_sp
    mov   cs:semaphore,0
    push  ax ; put return address back in stack
    ret
menu_1:
public menu_1
    push  ax
    call  save_all
    call  menu_1a
    call  restore_all
    pop   ax
    iret
keystrokes dw 011bh
     dw 3b00h,3c00h,3d00h,3e00h,3f00h,4000h,4100h,4200h,4300h,4400h
     dw 0231h,0332h,0433h,0534h,0635h,0736h,0837h,0938h,0a39h,0b3ah
actions    dw do_esc
     dw func1,func2,func3,func4,func5,func6,func7,func8,func9,func10
     dw func1,func2,func3,func4,func5,func6,func7,func8,func9,func10
do_esc:
    lea  si,window
    call undo_window
    ret

menu_1a:
public menu_1a
    lea  si,window
    call do_window
no_key:
    mov   ah,0
    int   16h
; keystroke in ax
    lea  di,keystrokes
    mov  cx,21
    cld
repne scasw
    jne  no_key
    dec  di
    dec  di
    sub  di,offset keystrokes
    jmp  word ptr ds:actions[di]
func1:
; function one is rebooot like ctrl-alt-del
    call   blip
    call   blop
    jmp  cs:reset
func2:
    mov  ax,40h
    mov  es,ax
    mov  word ptr es:72h,0
    jmp  cs:reset
func3:
    lea  si,window
    call undo_window
    mov   es,cs:esreg
    mov   ds,cs:dsreg
; get and reset the psp
    mov   ah,51h
    mov   bx,0
    int   21h
; set the ds segment
    mov   ds,bx
    mov   es,bx
    mov   ah,50h
    int   21h
    pop   ax   ; return waiting
    call  restore_all
    pop   ax
    mov   al,0ffh
    mov   ah,4ch
    mov   cs:semaphore,0
    int   21h
    int   20h
func4:
    call   blip
    lea   si,interrupts
    mov   di,0
    push  es
    mov   es,di
    cld
    mov    cx,256
    cli
rep    movsw
    sti
    pop    es
    jmp  no_key
func5:
    lea  si,window
    call undo_window
    push  es
    les  si,dword ptr save_sp
    mov   ax,word ptr es:[si]+4  ; cs at entry
    mov   bp,es
    pop   es
    lea   di,csip
    call  storehex
    inc   di
    push  es
    mov   es,bp
    mov   ax,word ptr es:[si]+2  ; cs at entry
    pop   es
    call  storehex
; do the interrupts
  ; this is 2,b,4:4,b * 4 = 13*4= 52
    mov   bx,0
    push  ds
    mov   ax,0
    mov   ds,ax
    mov   si,0
    lea   di,int0
    mov   cx,4
it_loop0:
    push  cx
    push  di
    mov   cx,16
it_loop:
    push  cx
    push  di
    mov   ax,bx
    inc   bx
    call  storehexb
    add   di,6
    lodsw
    call  storehex
    sub   di,9
    lodsw
    call  storehex
    pop   di
    pop   cx
    add   di,52
    loop  it_loop
    pop   di
    pop   cx
    add   di,13
    loop  it_loop0
    pop   ds
    mov   ax,dsreg
    lea   di,ds_d
    call  storehex
    mov   ax,esreg
    lea   di,ds_e
    call  storehex
    mov   ax,save_sp
    lea   di,ds_2
    call  storehex
    mov   ax,save_ss
    lea   di,ds_s
    call  storehex
    lea  si,window2
    call do_window
    mov   ah,0
    int  16h
    lea  si,window2
    call undo_window
    lea  si,window
    call do_window
    jmp  no_key
func6:
extrn  cport:near
    call  cport
    jmp  no_key
func7:
extrn fixm:near
    lea   si,window
    call  undo_window
    call  fixm
    jc    no_success
    lea   si,fixm1
    jmp   show_fixm
no_success:
    lea   si,fixm2
show_fixm:
    push  si
    call do_window
    mov  ah,0
    int  16h
    pop  si
    call undo_window
    lea  si,window
    call do_window
    jmp  no_key
func8:
    lea  si,window
    call undo_window
    lea   si,info3
    push  si
    call do_window
    mov  ah,0
    int  16h
    pop  si
    call undo_window
; now undo all
    pop   ax    ; flush the return
    call  restore_all
    pop   ax
    int 3
    iret
func9:
    lea  si,window
    call undo_window
    mov  al,mode
    mov  ah,0
    int  10h
    jmp  menu_1a
func10:
    jmp  no_key
blip    proc  near
public blip
    mov   bx,250  ; starting freq
    mov   cx,750  ; ending frequency
    mov   dx,3    ; tone rate
; turn on tone
i0:
    push  cx
    push  bx
    in    al,61h
    or    al,3
    out    61h,al
; loop parameters
    mov    si,32
    cmp    bx,cx
    jle    i1
    neg    si
i1:
    mov    cx,bx
 ; set frequency
    push   dx
    mov    dx,12h
    mov    ax,34deh
    div    cx
    mov    cx,ax
    pop    dx
; set tone
    mov    al,cl
    out    42h,al
    mov    al,ch
    out    42h,al
; mov   cx,dx
i2:    loop i2
    pop    bx
    pop    cx
    cmp    bx,cx
    jg    ip3
    add    bx,si
    jmp    i0
ip3:
 ;turn off tone
    in  al,61h
    and al,11111100b
    out 61h,al
    ret
blip    endp
blop    proc  near
public blop
    mov   bx,650  ; starting freq
    mov   cx,150  ; ending frequency
    mov   dx,3    ; tone rate
; turn on tone
o0:
    push  cx
    push  bx
    in    al,61h
    or    al,3
    out    61h,al
; loop parameters
    mov    si,32
    mov    cx,bx
 ; set frequency
    push   dx
    mov    dx,12h
    mov    ax,34deh
    div    cx
    mov    cx,ax
    pop    dx
; set tone
    mov    al,cl
    out    42h,al
    mov    al,ch
    out    42h,al
; mov   cx,dx
o2:    loop o2
    pop    bx
    pop    cx
    cmp    bx,cx
    jl    op3
    sub    bx,si
    jmp    o0
op3:
 ;turn off tone
    in  al,61h
    and al,11111100b
    out 61h,al
    ret
blop    endp
_TEXT    ENDS
    END
